

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to make a language file for pywws &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="User guides" href="index.html" />
    <link rel="next" title="weather.ini - configuration file format" href="weather_ini.html" />
    <link rel="prev" title="How to configure pywws to post messages to Twitter" href="twitter.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="weather_ini.html" title="weather.ini - configuration file format"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="twitter.html" title="How to configure pywws to post messages to Twitter"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">User guides</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="how-to-make-a-language-file-for-pywws">
<h1>How to make a language file for pywws<a class="headerlink" href="#how-to-make-a-language-file-for-pywws" title="Permalink to this headline">¶</a></h1>
<ol class="arabic">
<li><p class="first">Introduction.</p>
<p>Some parts of pywws can be configured to use your local language instead
of British English. This requires an appropriate language file which
contains translations of the various strings used in pywws. The pywws
project relies on users to provide these translations. This document
describes how to create a language file.</p>
</li>
<li><p class="first">Dependencies.</p>
<p>As well as the pywws software you need to install the &#8216;gettext&#8217; GNU
internationalisation utilities package. This is available from the
standard repositories for most Linux distributions, or you can download it
from <a class="reference external" href="http://www.gnu.org/software/gettext/">http://www.gnu.org/software/gettext/</a> if you need to compile it
yourself.</p>
</li>
<li><p class="first">Getting started.</p>
<p>Your pywws directory should already have a subdirectory called languages.
This contains the existing set of language files, for example &#8216;sv.po&#8217;
contains the Swedish translations. If one of these languages is what you
need, then edit your weather.ini file and add a &#8216;language&#8217; entry to the
&#8216;[config]&#8217; section, for example:</p>
<div class="highlight-python"><pre>[config]
day end hour = 21
gnuplot encoding = iso_8859_1
language = sv</pre>
</div>
<p>If there isn&#8217;t already a file for your language, the rest of this document
tells you how to create one.</p>
</li>
<li><p class="first">Choose your language code.</p>
<p>Computers use IETF language tags (see
<a class="reference external" href="http://en.wikipedia.org/wiki/IETF_language_tag">http://en.wikipedia.org/wiki/IETF_language_tag</a>). For example, in the UK we
use &#8216;en_GB&#8217;. This has two parts: &#8216;en&#8217; for English, and &#8216;GB&#8217; for the
British version of it. To find the correct code for your language, consult
the list at
<a class="reference external" href="http://www.gnu.org/software/gettext/manual/gettext.html#Language-Codes">http://www.gnu.org/software/gettext/manual/gettext.html#Language-Codes</a>.</p>
</li>
<li><p class="first">Create a language file.</p>
<p>The &#8216;makefile&#8217; included with pywws can create a template file for you to
fill in. For example, to create a file for the French language:</p>
<div class="highlight-python"><pre>make lang LANG=fr</pre>
</div>
<p>This will ask you to confirm your email address, then create a file
&#8216;languages/fr.po&#8217;. You should now edit this file, filling in every msgstr
line with a translation of the msgid line immediately above it. The reason
for including your email address is so that anyone who has questions about
your translation can get in touch with you. Feel free to put in an invalid
address if you are concerned about privacy.</p>
<p>After you&#8217;ve edited your new language file it needs to be compiled so that
pywws can use it. This is also done by the makefile:</p>
<div class="highlight-python"><pre>make lang</pre>
</div>
<p>Don&#8217;t forget to do this every time you edit a language file.</p>
</li>
<li><p class="first">Test the pywws translation.</p>
<p>Edit the language entry in your weather.ini file to use your language code
(e.g. &#8216;fr&#8217;), then try using Plot.py to plot a graph. The X-axis of the
graph should now be labeled in your language, using the translation you
provided for &#8216;Time&#8217;, &#8216;Day&#8217; or &#8216;Date&#8217;.</p>
</li>
<li><p class="first">Send Jim the language file.</p>
<p>I&#8217;m sure you would like others to benefit from the work you&#8217;ve done in
making a new language file for pywws. Please, please, please send a copy
of your language file (for example fr.po) to <a class="reference external" href="mailto:jim&#37;&#52;&#48;jim-easterbrook&#46;me&#46;uk">jim<span>&#64;</span>jim-easterbrook<span>&#46;</span>me<span>&#46;</span>uk</a>.</p>
</li>
<li><p class="first">Update the language file.</p>
<p>As pywws is extended, new strings may be added which will require your
translation file to be extended as well. This is fairly easy to do. First
you need to remove the language master template file:</p>
<div class="highlight-python"><pre>rm languages/pywws.pot</pre>
</div>
<p>Now run the make command again as in section 5 above. This should add the
new strings to your language file, without changing the strings you&#8217;ve
already translated.</p>
<p>Comments or questions? Please subscribe to the pywws mailing list
<a class="reference external" href="http://groups.google.com/group/pywws">http://groups.google.com/group/pywws</a> and let us know.</p>
</li>
</ol>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="twitter.html"
                        title="previous chapter">How to configure pywws to post messages to Twitter</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="weather_ini.html"
                        title="next chapter">weather.ini - configuration file format</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="weather_ini.html" title="weather.ini - configuration file format"
             >next</a> |</li>
        <li class="right" >
          <a href="twitter.html" title="How to configure pywws to post messages to Twitter"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >User guides</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>